select
  an.numero as numero_animal
  , an.nome as nome_animal
  , pai.numero as numero_pai
  , pai.nome as nome_pai
  , mae.numero as numero_mae
  , mae.nome as nome_mae
  , ((select count(*) from lactacao re where re.cdanimal = an.cdanimal) + coalesce(an.numpartoentrada, 0)) as Ordem_Lactacao
  , (select
          sum((select producaototal from sp_calculaproducaototal(re.cdlactacao, coalesce(re.dtfim, an.dtbaixa, current_date))))
        from
          lactacao re
        where
          re.cdanimal = an.cdanimal
        group by
          re.cdanimal) as producao_vitalicia
  , (select max(re.pesototal) from leite re where ultlac.cdlactacao = re.cdlactacao) pico_ult_lac
  , ((select count(*) from lactacao re where re.cdanimal = mae.cdanimal) + coalesce(mae.numpartoentrada, 0)) as num_lactacao_mae
from
  animal an
  left join animal pai on pai.cdanimal = an.cdpai
  left join animal mae on mae.cdanimal = an.cdmae
  join lactacao ultlac on ultlac.cdlactacao =
    (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal order by re.dtinicio desc)
where
  an.tipoanimal = 'A'
  and an.animalrebanho = 1
order by
  an.numordenado
